-----------------------------------------------------------------------------------------------
-- Tweaks to TradeskillSchematic search
-----------------------------------------------------------------------------------------------
require "Apollo"
require "ChatSystemLib"
require "CraftingLib"

local TradeskillSearchFix = {}

function TradeskillSearchFix:new(o)
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

function TradeskillSearchFix:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		"Lib:ApolloFixes-1.0"
	}
	Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
	--Apollo.RegisterEventHandler("ObscuredAddonVisible", "onObscuredAddonVisible", self)
end

-- Fixed up functions
function TradeskillSearchFix:HelperSearchBuildResult(tSchematic, tSubSchem)
	if not tSchematic then
		return
	end

	local tSchematicToUse = tSubSchem and tSubSchem or tSchematic
	local bShowLock = not tSchematicToUse.bIsKnown and not tSchematicToUse.bIsOneUse
	local bShowMatsWarning = not bShowLock and not self:HelperHaveEnoughMaterials(tSchematicToUse)
	local bOneTime = not bShowLock and not bShowMatsWarning and tSchematicToUse.bIsOneUse
	if tSchematicToUse.bIsOneUse then
		tSchematicToUse.strName = "Prototype: "..tSchematicToUse.strName
	end
	local wndBottomItem = self:LoadByName("BottomItem", self.wndMain:FindChild("LeftSideSearchResultsList"), tSchematicToUse.strName..tSchematic.nSchematicId)
	wndBottomItem:FindChild("BottomItemBtn"):SetData(tSchematic) -- GOTCHA: The Button will intentionally always open the parent schematic
	wndBottomItem:FindChild("BottomItemLockIcon"):Show(bShowLock)
	wndBottomItem:FindChild("BottomItemOneTimeIcon"):Show(bOneTime)
	wndBottomItem:FindChild("BottomItemMatsWarningIcon"):Show(bShowMatsWarning)
	wndBottomItem:FindChild("BottomItemBtnText"):SetText(tSubSchem and String_GetWeaselString(Apollo.GetString("Tradeskills_SubAbrev"), tSubSchem.strName) or tSchematic.strName)
end

function TradeskillSearchFix:onLoad()
	ChatSystemLib.PostOnChannel(2, "TradeskillSearchFix is no longer needed. Feel free to uninstall it.")
end

function TradeskillSearchFix:onObscuredAddonVisible(strName)
	if strName == "TradeskillSchematics" then
		local tTradeskillSchematics = Apollo.GetAddon("TradeskillSchematics")
		if tTradeskillSchematics ~= nil then
			tTradeskillSchematics.HelperSearchBuildResult = TradeskillSearchFix.HelperSearchBuildResult
		end
	end
end

local TradeskillSearchFixInstance = TradeskillSearchFix:new()
TradeskillSearchFixInstance:Init()